.\"
.\" Copyright (c) 1993 Christopher G. Demetriou
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"      This product includes software developed by Christopher G. Demetriou.
.\" 3. The name of the author may not be used to endorse or promote products
.\"    derived from this software withough specific prior written permission
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\"	from: npx.4,v 1.1 1993/08/06 10:58:03 cgd Exp
.\" $FreeBSD: src/share/man/man4/man4.i386/npx.4,v 1.1.10.2 1999/09/05 11:27:02 peter Exp $
.\"
.Dd August 28, 1993
.Dt NPX 4 i386
.Os FreeBSD
.Sh NAME
.Nm npx
.Nd Numeric Processing Extension coprocessor and emulator
.Sh SYNOPSIS
.Cd "options MATH_EMULATE"
.\" XXX this is awful hackery to get it to work right... -- cgd
.Cd "device npx0 at isa? port" \&"IO_NPX0\&" tty irq 13 vector npxintr
.Sh DESCRIPTION
The
.Nm npx
driver enables the use of the system's Numeric Processing Extension
coprocessor,
if one is present.  Numeric processing extensions are present in
systems with
.Sy 486DX
CPUs and in systems with
.Sy 387
or
.Sy 487SX
coprocessors.  The
.Nm npx
driver is required for proper system functioning regardless
of whether or not a NPX is present.
.Pp
If there is no NPX present in the system, the "MATH_EMULATE"
option must be defined in the kernel configuration file.
It will provide support for the instructions normally executed
by the NPX.  If there is no NPX in the system and the kernel
is not built with math emulation, the system will not boot.
.Sh CAVEATS
The emulator is much slower than the NPX coprocessor.
This will result in poor floating-point math performance
if the emulator must be used.
.Sh BUGS
There are lots of them, especially on cheap motherboards.  In particular,
some motherboards do not have the interrupt lines from the NPX to
the CPU wired properly.  If this is the case, the emulator must be used
if consistent system operation is desired.
.Pp
Emulation of the transcendental functions instructions is incorrect.
Emulation of other instructions is suspect.
